<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackageAdditionalElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackageAdditionalElement extends AbstractStructArrayBase
{
    /**
     * The PackageSupplement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackageAdditionalElement[]
     */
    public $PackageSupplement;
    /**
     * Constructor method for ArrayOfJP_PackageAdditionalElement
     * @uses ArrayOfJP_PackageAdditionalElement::setPackageSupplement()
     * @param \StructType\JP_PackageAdditionalElement[] $packageSupplement
     */
    public function __construct(array $packageSupplement = array())
    {
        $this
            ->setPackageSupplement($packageSupplement);
    }
    /**
     * Get PackageSupplement value
     * @return \StructType\JP_PackageAdditionalElement[]|null
     */
    public function getPackageSupplement()
    {
        return $this->PackageSupplement;
    }
    /**
     * Set PackageSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageAdditionalElement[] $packageSupplement
     * @return \ArrayType\ArrayOfJP_PackageAdditionalElement
     */
    public function setPackageSupplement(array $packageSupplement = array())
    {
        foreach ($packageSupplement as $arrayOfJP_PackageAdditionalElementPackageSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackageAdditionalElementPackageSupplementItem instanceof \StructType\JP_PackageAdditionalElement) {
                throw new \InvalidArgumentException(sprintf('The PackageSupplement property can only contain items of \StructType\JP_PackageAdditionalElement, "%s" given', is_object($arrayOfJP_PackageAdditionalElementPackageSupplementItem) ? get_class($arrayOfJP_PackageAdditionalElementPackageSupplementItem) : gettype($arrayOfJP_PackageAdditionalElementPackageSupplementItem)), __LINE__);
            }
        }
        $this->PackageSupplement = $packageSupplement;
        return $this;
    }
    /**
     * Add item to PackageSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageAdditionalElement $item
     * @return \ArrayType\ArrayOfJP_PackageAdditionalElement
     */
    public function addToPackageSupplement(\StructType\JP_PackageAdditionalElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackageAdditionalElement) {
            throw new \InvalidArgumentException(sprintf('The PackageSupplement property can only contain items of \StructType\JP_PackageAdditionalElement, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PackageSupplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackageAdditionalElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PackageSupplement
     */
    public function getAttributeName()
    {
        return 'PackageSupplement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_PackageAdditionalElement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
